## srpc 0.9.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(srpc
	VERSION 0.9.6
	LANGUAGES C CXX)

#### CHECK

include(CheckIncludeFile)
include(CheckIncludeFileCXX)

check_include_file("lz4.h" LZ4_INSTALLED)
if (NOT LZ4_INSTALLED)
	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
		message( FATAL_ERROR "Lz4 is neither installed not in third_party!")
	endif ()
else ()
	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
		message("Lz4 third_party FOUND. Use for source code dependencies.")
		set(LZ4_INSTALLED 0)
	endif ()
endif ()

check_include_file_cxx("snappy.h" SNAPPY_INSTALLED)
if (NOT SNAPPY_INSTALLED)
	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
		message( FATAL_ERROR "Snappy is neither installed not in third_party!")
	endif ()
else ()
	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
		message("Snappy third_party FOUND. Use for source code dependencies.")
		set(SNAPPY_INSTALLED 0)
	endif ()
endif ()

check_include_file_cxx("workflow/Workflow.h" WORKFLOW_INSTALLED)
if (NOT WORKFLOW_INSTALLED)
	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
		message( FATAL_ERROR "Workflow is neither installed not in third_party!")
	endif ()
else ()
	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
		message("Workflow third_party FOUND. Use for source code dependencies.")
		set(WORKFLOW_INSTALLED 0)
	endif ()
endif ()

find_program(PROTOC "protoc")
if(${PROTOC} STREQUAL "PROTOC-NOTFOUND")
    message( FATAL_ERROR "Protobuf compiler is missing!")
endif()

#### PREPARE

set(INC_DIR ${PROJECT_SOURCE_DIR}/_include CACHE PATH "srpc inc")
set(LIB_DIR ${PROJECT_SOURCE_DIR}/_lib CACHE PATH "srpc lib")
set(BIN_DIR ${PROJECT_SOURCE_DIR}/_bin CACHE PATH "srpc bin")

include(GNUInstallDirs)

set(CMAKE_CONFIG_INSTALL_FILE ${PROJECT_BINARY_DIR}/config.toinstall.cmake)
set(CMAKE_CONFIG_INSTALL_DIR ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${LIB_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${LIB_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${BIN_DIR})

add_custom_target(
	LINK_HEADERS ALL
	COMMENT "link headers..."
)

INCLUDE(CMakeLists_Headers.txt)

macro(makeLink src dest target)
	add_custom_command(
		TARGET ${target} PRE_BUILD
		COMMAND ${CMAKE_COMMAND} -E copy_if_different ${src} ${dest}
		DEPENDS ${dest}
	)
endmacro()

add_custom_command(
	TARGET LINK_HEADERS PRE_BUILD
	COMMAND ${CMAKE_COMMAND} -E make_directory ${INC_DIR}/${PROJECT_NAME}
)

foreach(header_file ${INCLUDE_HEADERS})
	string(REPLACE "/" ";" arr ${header_file})
	list(GET arr -1 file_name)
	makeLink(${PROJECT_SOURCE_DIR}/${header_file} ${INC_DIR}/${PROJECT_NAME}/${file_name} LINK_HEADERS)
endforeach()

add_subdirectory(src)

#### CONFIG

include(CMakePackageConfigHelpers)
set(CONFIG_INC_DIR ${INC_DIR})
set(CONFIG_LIB_DIR ${LIB_DIR})
if(NOT VCPKG_TOOLCHAIN)
	set(CONFIG_BIN_DIR ${BIN_DIR})	
else()
	set(CONFIG_BIN_DIR ${CMAKE_INSTALL_PREFIX}/tools/srpc)
endif()

configure_package_config_file(
	${PROJECT_NAME}-config.cmake.in
	${PROJECT_SOURCE_DIR}/${PROJECT_NAME}-config.cmake
	INSTALL_DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	PATH_VARS CONFIG_INC_DIR CONFIG_LIB_DIR CONFIG_BIN_DIR
)

set(CONFIG_INC_DIR ${CMAKE_INSTALL_INCLUDEDIR})
set(CONFIG_LIB_DIR ${CMAKE_INSTALL_LIBDIR})
set(CONFIG_BIN_DIR ${CMAKE_INSTALL_BINDIR})
configure_package_config_file(
	${PROJECT_NAME}-config.cmake.in
	${CMAKE_CONFIG_INSTALL_FILE}
	INSTALL_DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	PATH_VARS CONFIG_INC_DIR CONFIG_LIB_DIR CONFIG_BIN_DIR
)

install(
	FILES ${CMAKE_CONFIG_INSTALL_FILE}
	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
	COMPONENT devel
	RENAME ${PROJECT_NAME}-config.cmake
)

#### PACK

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Sogou RPC")
set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})

# set(CPACK_RPM_PRE_INSTALL_SCRIPT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/pre_script.sh)
# set(CPACK_RPM_POST_INSTALL_SCRIPT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/post_script.sh)

execute_process(
	COMMAND git log -n1 --format=%ad --date=short
	RESULT_VARIABLE GIT_LOG_RET
	OUTPUT_VARIABLE GIT_YMD
	OUTPUT_STRIP_TRAILING_WHITESPACE
)

if (NOT GIT_LOG_RET EQUAL 0)
	set(GIT_YMD 0)
endif()

string(REPLACE "-" "" RELEASE_LABEL ${GIT_YMD})
set(CPACK_RPM_PACKAGE_RELEASE ${RELEASE_LABEL})

set(CPACK_RPM_COMPONENT_INSTALL ON)
set(CPACK_COMPONENTS_ALL devel)
set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
set(CPACK_RPM_PACKAGE_RELEASE_DIST ON)

set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/lib64/cmake)

set(PB_PACKAGE_REQUIRED "protobuf-devel")

set(CPACK_RPM_DEVEL_PACKAGE_REQUIRES "workflow-devel >= 0.9.9, ${PB_PACKAGE_REQUIRED}")

install(
	FILES ${INCLUDE_HEADERS}
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}
	COMPONENT devel
)

install(
	FILES README.md
	DESTINATION "${CMAKE_INSTALL_DOCDIR}-${PROJECT_VERSION}"
	COMPONENT devel
)

set(CPACK_RPM_SPEC_MORE_DEFINE "%define __spec_install_post /bin/true") # disable strip
set(CPACK_GENERATOR "RPM")

include(CPack)

=== benchmark/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(srpc_benchmark
		LANGUAGES C CXX
)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})

if (NOT "$ENV{LIBRARY_PATH}" STREQUAL "")
	string(REPLACE ":" ";" LIBRARY_PATH $ENV{LIBRARY_PATH})
	set(CMAKE_SYSTEM_LIBRARY_PATH ${LIBRARY_PATH};${CMAKE_SYSTEM_LIBRARY_PATH})
endif ()

if (NOT "$ENV{CPLUS_INCLUDE_PATH}" STREQUAL "")
	string(REPLACE ":" ";" INCLUDE_PATH $ENV{CPLUS_INCLUDE_PATH})
	set(CMAKE_SYSTEM_INCLUDE_PATH ${INCLUDE_PATH};${CMAKE_SYSTEM_INCLUDE_PATH})
endif ()

find_package(OpenSSL REQUIRED)

set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
if (WIN32)
	find_package(Protobuf CONFIG REQUIRED)
else ()
	find_package(Protobuf REQUIRED)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/lz4/lib/lz4.h")
	set(LZ4_LIB lz4)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/snappy/cmake")
	set(SNAPPY_LIB snappy)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
	find_package(Workflow REQUIRED CONFIG HINTS ../workflow)
endif ()

#if (APPLE)
#	if (WORKFLOW_INCLUDE_DIR)
#		set (WORKFLOW_INCLUDE_DIR ${Workflow_DIR}/_include)
#		set (WORKFLOW_LIB_DIR ${Workflow_DIR}/_lib)
#	else ()
#		find_package(Workflow REQUIRED)
#	endif ()
#else ()
#	find_package(Workflow REQUIRED)
#endif()

find_package(srpc REQUIRED CONFIG HINTS ..)
include_directories(
	${OPENSSL_INCLUDE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	${Protobuf_INCLUDE_DIR}
	${WORKFLOW_INCLUDE_DIR}
	${SRPC_INCLUDE_DIR}
)

if (WIN32)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/Debug/srpc_generator.exe)
else ()
	get_filename_component(Protobuf_LIB_DIR ${Protobuf_LIBRARY} DIRECTORY)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/srpc_generator)
endif ()

protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS benchmark_pb.proto)

add_custom_target(
	BENCHMARK_GEN ALL
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/benchmark_pb.proto  ${PROJECT_SOURCE_DIR}
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/benchmark_thrift.thrift ${PROJECT_SOURCE_DIR}
	COMMENT "sprc generator..."
)

if (WIN32)
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /Zc:__cplusplus /std:c++14")
else ()
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
endif ()

if (APPLE)
	set(SRPC_LIB srpc workflow pthread OpenSSL::SSL OpenSSL::Crypto protobuf z)
elseif (WIN32)
	set(SRPC_LIB srpc workflow ws2_32 wsock32 OpenSSL::SSL OpenSSL::Crypto)
else ()
	if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/snappy/cmake)
		set(SRPC_LIB srpc snappy lz4)
	else ()
		set(SRPC_LIB srpc)
	endif ()
endif ()

add_executable(server server.cc ${PROTO_SRCS} ${PROTO_HDRS})
target_link_libraries(server ${SRPC_LIB})
add_dependencies(server BENCHMARK_GEN)

add_executable(client client.cc ${PROTO_SRCS} ${PROTO_HDRS})
target_link_libraries(client ${SRPC_LIB})
add_dependencies(client BENCHMARK_GEN)

add_executable(client_cdf client_cdf.cc ${PROTO_SRCS} ${PROTO_HDRS})
target_link_libraries(client_cdf ${SRPC_LIB})
add_dependencies(client_cdf BENCHMARK_GEN)

add_executable(proxy proxy.cc ${PROTO_SRCS} ${PROTO_HDRS})
target_link_libraries(proxy ${SRPC_LIB})
add_dependencies(proxy BENCHMARK_GEN)

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

if (NOT "$ENV{LIBRARY_PATH}" STREQUAL "")
	string(REPLACE ":" ";" LIBRARY_PATH $ENV{LIBRARY_PATH})
	set(CMAKE_SYSTEM_LIBRARY_PATH ${LIBRARY_PATH};${CMAKE_SYSTEM_LIBRARY_PATH})
endif ()

if (NOT "$ENV{CPLUS_INCLUDE_PATH}" STREQUAL "")
	string(REPLACE ":" ";" INCLUDE_PATH $ENV{CPLUS_INCLUDE_PATH})
	set(CMAKE_SYSTEM_INCLUDE_PATH ${INCLUDE_PATH};${CMAKE_SYSTEM_INCLUDE_PATH})
endif ()

find_package(OpenSSL REQUIRED)

set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
if (WIN32)
	find_package(Protobuf CONFIG REQUIRED)
else ()
	find_package(Protobuf REQUIRED)
endif ()

if (WIN32)
	set (HAVE_SYS_UIO_H_01 false)
else ()
	set (HAVE_SYS_UIO_H_01 true)
endif ()

if(NOT VCPKG_TOOLCHAIN)

	# Try to find the package if workflow is not installed, otherwise proceed with find_package()
	if (NOT WORKFLOW_INSTALLED)
		find_package(Workflow REQUIRED CONFIG HINTS ../workflow)
	endif ()

	if (NOT SNAPPY_INSTALLED)
		set(SNAPPY_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/snappy)
		configure_file(${SNAPPY_DIR}/cmake/config.h.in ${SNAPPY_DIR}/config.h)
		configure_file(${SNAPPY_DIR}/snappy-stubs-public.h.in ${SNAPPY_DIR}/snappy-stubs-public.h)
#	else ()
#		find_package(Snappy REQUIRED CONFIG)
#		if (${Snappy_CONSIDERED_VERSIONS} VERSION_LESS 1.1.6)
#			message(FATAL_ERROR "Snappy version is less than 1.1.6")
#		endif ()
	endif ()

else()
	find_package(Workflow REQUIRED CONFIG)
endif()

include_directories(
	${OPENSSL_INCLUDE_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}
	${Protobuf_INCLUDE_DIR}
	${WORKFLOW_INCLUDE_DIR}
	${INC_DIR}/srpc
)

if (WIN32)
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /Zc:__cplusplus /std:c++14")
else ()
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
endif ()

add_subdirectory(generator)

set(SRC
	rpc_buffer.cc
	rpc_global.cc
)

add_subdirectory(module)
add_subdirectory(thrift)
add_subdirectory(compress)
add_subdirectory(message)

add_dependencies(module LINK_HEADERS)
add_dependencies(thrift LINK_HEADERS)
add_dependencies(compress LINK_HEADERS)
add_dependencies(message LINK_HEADERS)

add_library(
	${PROJECT_NAME} STATIC
	${SRC}
	$<TARGET_OBJECTS:module>
	$<TARGET_OBJECTS:thrift>
	$<TARGET_OBJECTS:compress>
	$<TARGET_OBJECTS:message>
)
add_dependencies(${PROJECT_NAME} LINK_HEADERS)
if (WIN32)
	target_compile_definitions(
		${PROJECT_NAME} PRIVATE
		strdup=_strdup
		strcasecmp=_stricmp
		strncasecmp=_strnicmp
	)
endif ()

install(
	TARGETS ${PROJECT_NAME}
	ARCHIVE
	DESTINATION ${CMAKE_INSTALL_LIBDIR}
	COMPONENT devel
)

if (APPLE)
	set(LIBSO ${LIB_DIR}/libsrpc.a)
else ()
	set(LIBSO ${LIB_DIR}/libsrpc.so)
	add_custom_target(
		SCRIPT_SHARED_LIB ALL
		COMMAND ${CMAKE_COMMAND} -E echo 'GROUP ( libsrpc.a AS_NEEDED ( libz.so libworkflow.so libprotobuf.so ) ) ' > ${LIBSO}
	)
	add_dependencies(SCRIPT_SHARED_LIB ${PROJECT_NAME})
endif ()

install(
	FILES ${LIBSO}
	DESTINATION ${CMAKE_INSTALL_LIBDIR}
	COMPONENT devel
)

install (
	TARGETS ${CMAKE_PROJECT_NAME} EXPORT ${CMAKE_PROJECT_NAME}-targets
	ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install (
	EXPORT ${CMAKE_PROJECT_NAME}-targets
	FILE ${CMAKE_PROJECT_NAME}-targets.cmake
	DESTINATION "${CMAKE_CONFIG_INSTALL_DIR}"
)

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(srpc_test
		LANGUAGES C CXX
)

if (NOT "$ENV{LIBRARY_PATH}" STREQUAL "")
	string(REPLACE ":" ";" LIBRARY_PATH $ENV{LIBRARY_PATH})
	set(CMAKE_SYSTEM_LIBRARY_PATH ${LIBRARY_PATH};${CMAKE_SYSTEM_LIBRARY_PATH})
endif ()

if (NOT "$ENV{CPLUS_INCLUDE_PATH}" STREQUAL "")
	string(REPLACE ":" ";" INCLUDE_PATH $ENV{CPLUS_INCLUDE_PATH})
	set(CMAKE_SYSTEM_INCLUDE_PATH ${INCLUDE_PATH};${CMAKE_SYSTEM_INCLUDE_PATH})
endif ()

find_package(OpenSSL REQUIRED)

set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
if (WIN32)
	find_package(Protobuf CONFIG REQUIRED)
else ()
	find_package(Protobuf REQUIRED)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/lz4/lib/lz4.h")
	set(LZ4_LIB lz4)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/snappy/cmake")
	set(SNAPPY_LIB snappy)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
	find_package(Workflow REQUIRED CONFIG HINTS ../workflow)
endif ()

#if (APPLE)
#	if (WORKFLOW_INCLUDE_DIR)
#		set (WORKFLOW_INCLUDE_DIR ${Workflow_DIR}/_include)
#		set (WORKFLOW_LIB_DIR ${Workflow_DIR}/_lib)
#	else ()
#		find_package(Workflow REQUIRED)
#	endif ()
#else ()
#	find_package(Workflow REQUIRED)
#endif()

find_package(srpc REQUIRED CONFIG HINTS ..)
include_directories(
	${OPENSSL_INCLUDE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	${Protobuf_INCLUDE_DIR}
	${SRPC_INCLUDE_DIR}
	${WORKFLOW_INCLUDE_DIR}
)

if (WIN32)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/Debug/srpc_generator.exe)
else ()
	get_filename_component(Protobuf_LIB_DIR ${Protobuf_LIBRARY} DIRECTORY)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/srpc_generator)
endif ()

find_program(CMAKE_MEMORYCHECK_COMMAND valgrind)
set(memcheck_command ${CMAKE_MEMORYCHECK_COMMAND} ${CMAKE_MEMORYCHECK_COMMAND_OPTIONS} --error-exitcode=1 --leak-check=full --show-leak-kinds=all)

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

enable_testing()
if (WIN32)
	find_package(GTest CONFIG REQUIRED)
else ()
	find_package(GTest REQUIRED)
endif ()

if (WIN32)
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /Zc:__cplusplus /std:c++14")
else ()
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
endif ()

set(TEST_LIST
	unittest
)

protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS test_pb.proto)

add_custom_target(
	SRPC_GEN ALL
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/test_pb.proto ${PROJECT_SOURCE_DIR}
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/test_thrift.thrift ${PROJECT_SOURCE_DIR}
	COMMENT "sprc generator..."
)

set(GTEST_LIB GTest::GTest GTest::Main)

if (APPLE)
	set(SRPC_LIB srpc workflow pthread OpenSSL::SSL OpenSSL::Crypto protobuf z)
elseif (WIN32)
	set(SRPC_LIB srpc workflow ws2_32 wsock32 OpenSSL::SSL OpenSSL::Crypto)
	set(GTEST_LIB GTest::gtest GTest::gtest_main)
else ()
	if (SNAPPY_INSTALLED)
		set(SNAPPY_LIB snappy)
	endif ()

	if (LZ4_INSTALLED)
		set(LZ4_LIB lz4)
	endif ()

	set(SRPC_LIB srpc ${SNAPPY_LIB} ${LZ4_LIB})
endif ()

foreach(src ${TEST_LIST})
	add_executable(${src} EXCLUDE_FROM_ALL ${src}.cc ${PROTO_SRCS} ${PROTO_HDRS})
	target_link_libraries(${src} ${SRPC_LIB} ${GTEST_LIB})
	add_test(${src} ${src})
	add_dependencies(${src} SRPC_GEN)
	add_dependencies(check ${src})
endforeach()

if (WIN32)
	set(memcheck nothing)
else ()
	foreach(src ${TEST_LIST})
		add_test(${src}-memory-check ${memcheck_command} ./${src})
	endforeach()
endif ()

=== tutorial/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")

project(srpc_tutorial
		LANGUAGES C CXX
)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})

if (NOT "$ENV{LIBRARY_PATH}" STREQUAL "")
	string(REPLACE ":" ";" LIBRARY_PATH $ENV{LIBRARY_PATH})
	set(CMAKE_SYSTEM_LIBRARY_PATH ${LIBRARY_PATH};${CMAKE_SYSTEM_LIBRARY_PATH})
endif ()

if (NOT "$ENV{CPLUS_INCLUDE_PATH}" STREQUAL "")
	string(REPLACE ":" ";" INCLUDE_PATH $ENV{CPLUS_INCLUDE_PATH})
	set(CMAKE_SYSTEM_INCLUDE_PATH ${INCLUDE_PATH};${CMAKE_SYSTEM_INCLUDE_PATH})
endif ()

find_package(OpenSSL REQUIRED)

set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
if (WIN32)
	find_package(Protobuf CONFIG REQUIRED)
else ()
	find_package(Protobuf REQUIRED)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/lz4/lib/lz4.h")
	set(LZ4_LIB lz4)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../third_party/snappy/cmake")
	set(SNAPPY_LIB snappy)
endif ()

if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/workflow/workflow-config.cmake.in")
	find_package(Workflow REQUIRED CONFIG HINTS ../workflow)
endif ()

find_package(ZLIB REQUIRED)

#if (APPLE)
#	if (WORKFLOW_INCLUDE_DIR)
#		set (WORKFLOW_INCLUDE_DIR ${Workflow_DIR}/_include)
#		set (WORKFLOW_LIB_DIR ${Workflow_DIR}/_lib)
#	else ()
#		find_package(Workflow REQUIRED)
#	endif ()
#else ()
#	find_package(Workflow REQUIRED)
#endif()

find_package(srpc REQUIRED CONFIG HINTS ..)
include_directories(
	${OPENSSL_INCLUDE_DIR}
	${CMAKE_CURRENT_BINARY_DIR}
	${Protobuf_INCLUDE_DIR}
	${WORKFLOW_INCLUDE_DIR}
	${SRPC_INCLUDE_DIR}
)

if (WIN32)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/Debug/srpc_generator.exe)
else ()
	get_filename_component(Protobuf_LIB_DIR ${Protobuf_LIBRARY} DIRECTORY)
	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/srpc_generator)
endif ()

protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS echo_pb.proto)
protobuf_generate_cpp(HELLOWORLD_SRCS HELLOWORLD_HDRS helloworld.proto)

add_custom_target(
	TURORIAL_GEN ALL
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/echo_pb.proto  ${PROJECT_SOURCE_DIR}
	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/echo_thrift.thrift ${PROJECT_SOURCE_DIR}
	COMMAND ${SRPC_GEN_PROGRAM} protobuf ${PROJECT_SOURCE_DIR}/helloworld.proto  ${PROJECT_SOURCE_DIR}
	COMMENT "sprc generator..."
)

if (WIN32)
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /Zc:__cplusplus /std:c++14")
else ()
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
endif ()

set(TUTORIAL_PB_LIST
	tutorial-01-srpc_pb_server
	tutorial-02-srpc_pb_client
	tutorial-05-brpc_pb_server
	tutorial-06-brpc_pb_client
	tutorial-09-client_task
	tutorial-10-server_async
	tutorial-15-srpc_pb_proxy
)

if (APPLE)
	set(SRPC_LIB srpc workflow pthread OpenSSL::SSL OpenSSL::Crypto protobuf z)
elseif (WIN32)
	set(SRPC_LIB srpc workflow ws2_32 wsock32 OpenSSL::SSL OpenSSL::Crypto protobuf::libprotobuf ZLIB::ZLIB)
else ()
	set(SRPC_LIB srpc ${SNAPPY_LIB} ${LZ4_LIB})
endif ()

foreach(src ${TUTORIAL_PB_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc ${PROTO_SRCS} ${PROTO_HDRS})
	target_link_libraries(${bin_name} ${SRPC_LIB})
	add_dependencies(${bin_name} TURORIAL_GEN)
endforeach()

set(TUTORIAL_THRIFT_LIST
	tutorial-03-srpc_thrift_server
	tutorial-04-srpc_thrift_client
	tutorial-07-thrift_thrift_server
	tutorial-08-thrift_thrift_client
)

foreach(src ${TUTORIAL_THRIFT_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc)
	target_link_libraries(${bin_name} ${SRPC_LIB})
	add_dependencies(${bin_name} TURORIAL_GEN)
endforeach()

set(TUTORIAL_HELLOWORLD_LIST
	tutorial-11-trpc_pb_server
	tutorial-12-trpc_pb_client
	tutorial-13-trpc_http_server
	tutorial-14-trpc_http_client
)

foreach(src ${TUTORIAL_HELLOWORLD_LIST})
	string(REPLACE "-" ";" arr ${src})
	list(GET arr -1 bin_name)
	add_executable(${bin_name} ${src}.cc ${HELLOWORLD_SRCS} ${HELLOWORLD_HDRS})
	target_link_libraries(${bin_name} ${SRPC_LIB})
	add_dependencies(${bin_name} TURORIAL_GEN)
endforeach()

=== src/compress/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(compress)

set(SRC
	rpc_compress.cc
	rpc_compress_snappy.cc
)

set_property(SOURCE rpc_compress_snappy.cc APPEND PROPERTY COMPILE_OPTIONS "-fno-rtti")

if (NOT VCPKG_TOOLCHAIN)

	if (SNAPPY_INSTALLED)
		set(SNAPPY_LIB snappy)
	else ()
		set(SNAPPY_SRC
			../../third_party/snappy/config.h
			../../third_party/snappy/snappy-internal.h
			../../third_party/snappy/snappy-sinksource.cc
			../../third_party/snappy/snappy-sinksource.h
			../../third_party/snappy/snappy-stubs-internal.cc
			../../third_party/snappy/snappy-stubs-internal.h
			../../third_party/snappy/snappy-stubs-public.h
			../../third_party/snappy/snappy.cc
			../../third_party/snappy/snappy.h
			)
	endif ()

	if (LZ4_INSTALLED)
		set(LZ4_LIB lz4)
	else ()
		set(LZ4_SRC
			../../third_party/lz4/lib/lz4.c
			../../third_party/lz4/lib/lz4.h
			../../third_party/lz4/lib/lz4hc.h
			../../third_party/lz4/lib/lz4hc.c
			../../third_party/lz4/lib/lz4frame.h
			../../third_party/lz4/lib/lz4frame.c
			../../third_party/lz4/lib/xxhash.c
			../../third_party/lz4/lib/xxhash.h
			)
	endif ()

	add_library(
		${PROJECT_NAME} OBJECT
		${SRC}
		${SNAPPY_SRC}
		${LZ4_SRC}
	)

#	if ("${SNAPPY_INSTALLED}${LZ4_INSTALLED}")
#		target_link_libraries(${PROJECT_NAME} ${SNAPPY_LIB} ${LZ4_LIB})
#	endif()
else()
	add_library(
		${PROJECT_NAME} OBJECT
		${SRC}
	)
	target_link_libraries(${PROJECT_NAME} lz4 snappy)
endif()

=== src/message/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(message)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(PROTO_LIST rpc_meta.proto rpc_meta_brpc.proto rpc_span.proto rpc_meta_trpc.proto)
protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS ${PROTO_LIST})

set(SRC
	rpc_message_brpc.cc
	rpc_message_srpc.cc
	rpc_message_thrift.cc
	rpc_message_trpc.cc
	${PROTO_SRCS} ${PROTO_HDRS}
)

add_library(${PROJECT_NAME} OBJECT ${SRC})
if (WIN32)
	target_compile_definitions(
		${PROJECT_NAME} PRIVATE
		strdup=_strdup
		strcasecmp=_stricmp
		strncasecmp=_strnicmp
	)
endif ()

=== src/module/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(module)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(PROTO_LIST
	opentelemetry_common.proto
	opentelemetry_resource.proto
	opentelemetry_trace.proto
	opentelemetry_trace_service.proto)

protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS ${PROTO_LIST})

set(SRC
	rpc_module.cc
	rpc_span_policies.cc
	${PROTO_SRCS} ${PROTO_HDRS}
)

add_library(${PROJECT_NAME} OBJECT ${SRC})

=== debian/changelog ===
srpc (0.9.6-1) unstable; urgency=low

  * Initial release. Closes: #1004346

 -- Lance Lin <lqi254@protonmail.com>  Thu, 10 Feb 2022 20:53:49 +0700

=== debian/control ===
Source: srpc
Section: libs
Priority: optional
Maintainer: Lance Lin <lqi254@protonmail.com>
Build-Depends: cmake, debhelper (>= 13), debhelper-compat (= 13),
		libworkflow-dev, libssl-dev,
		libsnappy-dev (>= 1.1.6), libprotobuf-dev (>= 3.12.0),
		protobuf-compiler, liblz4-dev
Standards-Version: 4.6.0
Homepage: https://github.com/sogou/srpc
Vcs-Git: https://salsa.debian.org/debian/srpc.git
Vcs-Browser: https://salsa.debian.org/debian/srpc
Rules-Requires-Root: no

Package: libsrpc
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Sogou RPC Library (SRPC)
 SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
 many small and medium-sized companies.  It handles hundreds of millions of
 requests every day, mainly from search engines. It supports two common IDLs:
 protobuf and thrift, and implements several commonly used rpc protocols.
 It is also an open source version of Tencent's enterprise-level RPC protocol,
 tRPC.
 .
 This package contains the runtime library.

Package: libsrpc-dev
Architecture: any
Depends: libsrpc (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Sogou RPC Library (SRPC)
 SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
 many small and medium-sized companies.  It handles hundreds of millions of
 requests every day, mainly from search engines. It supports two common IDLs:
 protobuf and thrift, and implements several commonly used rpc protocols.
 It is also an open source version of Tencent's enterprise-level RPC protocol,
 tRPC.
 .
 This package contains the development header files.

## srpc 0.9.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,36 +1,53 @@
 cmake_minimum_required(VERSION 3.6)
 set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING "build type")
+set(CMAKE_SKIP_RPATH TRUE)
 
 project(srpc
-	VERSION 0.9.6
+	VERSION 0.9.7
 	LANGUAGES C CXX)
+	
+###Options
+
+if (WIN32)
+	option(SRPC_BUILD_STATIC_RUNTIME "Use static runtime" ON)
+endif ()
 
 #### CHECK
 
 include(CheckIncludeFile)
 include(CheckIncludeFileCXX)
 
+find_library(LZ4_LIBRARY NAMES lz4)
 check_include_file("lz4.h" LZ4_INSTALLED)
-if (NOT LZ4_INSTALLED)
+if (NOT LZ4_INSTALLED AND ${LZ4_LIBRARY} STREQUAL "LZ4_LIBRARY-NOTFOUND")
 	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
 		message( FATAL_ERROR "Lz4 is neither installed not in third_party!")
 	endif ()
 else ()
 	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/lz4/lib/lz4.h")
 		message("Lz4 third_party FOUND. Use for source code dependencies.")
-		set(LZ4_INSTALLED 0)
+		set(LZ4_INSTALLED 0 CACHE INTERNAL "check_lz4_installed")
+	else ()
+		find_path(LZ4_INCLUDE_DIR NAMES "lz4.h")
+		include_directories(${LZ4_INCLUDE_DIR})
+		set(LZ4_INSTALLED 1 CACHE INTERNAL "check_lz4_installed")
 	endif ()
 endif ()
 
+find_package(Snappy)
 check_include_file_cxx("snappy.h" SNAPPY_INSTALLED)
-if (NOT SNAPPY_INSTALLED)
+if (NOT SNAPPY_INSTALLED AND NOT ${Snappy_FOUND})
 	if (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
 		message( FATAL_ERROR "Snappy is neither installed not in third_party!")
 	endif ()
 else ()
 	if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third_party/snappy/cmake")
 		message("Snappy third_party FOUND. Use for source code dependencies.")
-		set(SNAPPY_INSTALLED 0)
+		set(SNAPPY_INSTALLED 0 CACHE INTERNAL "check_snappy_installed")
+	else ()
+		find_path(Snappy_INCLUDE_DIR NAMES "snappy.h")
+		include_directories(${Snappy_INCLUDE_DIR})
+		set(SNAPPY_INSTALLED 1 CACHE INTERNAL "check_snappy_installed")
 	endif ()
 endif ()
 
@@ -91,6 +108,24 @@
 	makeLink(${PROJECT_SOURCE_DIR}/${header_file} ${INC_DIR}/${PROJECT_NAME}/${file_name} LINK_HEADERS)
 endforeach()
 
+if (WIN32)
+	if (SRPC_BUILD_STATIC_RUNTIME)
+		set(CompilerFlags
+				CMAKE_CXX_FLAGS
+				CMAKE_CXX_FLAGS_DEBUG
+				CMAKE_CXX_FLAGS_RELEASE
+				CMAKE_CXX_FLAGS_MINSIZEREL
+				CMAKE_C_FLAGS
+				CMAKE_C_FLAGS_DEBUG
+				CMAKE_C_FLAGS_RELEASE
+				CMAKE_C_FLAGS_MINSIZEREL
+				)
+		foreach(CompilerFlag ${CompilerFlags})
+			string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
+		endforeach ()
+	endif ()
+endif ()
+
 add_subdirectory(src)
 
 #### CONFIG
@@ -98,10 +133,14 @@
 include(CMakePackageConfigHelpers)
 set(CONFIG_INC_DIR ${INC_DIR})
 set(CONFIG_LIB_DIR ${LIB_DIR})
-if(NOT VCPKG_TOOLCHAIN)
-	set(CONFIG_BIN_DIR ${BIN_DIR})	
+
+if (VCPKG_TOOLCHAIN AND EXISTS "${CMAKE_INSTALL_PREFIX}/tools/srpc")
+	set(CONFIG_BIN_DIR ${CMAKE_INSTALL_PREFIX}/tools/srpc)
+	set(WITH_VCPKG_TOOLCHAIN 1 CACHE INTERNAL "build_with_vcpkg_toolchain")
+	message("Install with VCPKG toolchain. Dir ${CMAKE_INSTALL_PREFIX}/tools/srpc.")
 else()
-	set(CONFIG_BIN_DIR ${CMAKE_INSTALL_PREFIX}/tools/srpc)
+	set(CONFIG_BIN_DIR ${BIN_DIR})
+	set(WITH_VCPKG_TOOLCHAIN 0 CACHE INTERNAL "build_with_vcpkg_toolchain")
 endif()
 
 configure_package_config_file(
@@ -121,6 +160,12 @@
 	PATH_VARS CONFIG_INC_DIR CONFIG_LIB_DIR CONFIG_BIN_DIR
 )
 
+write_basic_package_version_file(
+	${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
+	VERSION ${WORKFLOW_VERSION}
+	COMPATIBILITY AnyNewerVersion
+)
+
 install(
 	FILES ${CMAKE_CONFIG_INSTALL_FILE}
 	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
@@ -128,38 +173,11 @@
 	RENAME ${PROJECT_NAME}-config.cmake
 )
 
-#### PACK
-
-set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Sogou RPC")
-set(CPACK_PACKAGE_VERSION ${PROJECT_VERSION})
-
-# set(CPACK_RPM_PRE_INSTALL_SCRIPT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/pre_script.sh)
-# set(CPACK_RPM_POST_INSTALL_SCRIPT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/post_script.sh)
-
-execute_process(
-	COMMAND git log -n1 --format=%ad --date=short
-	RESULT_VARIABLE GIT_LOG_RET
-	OUTPUT_VARIABLE GIT_YMD
-	OUTPUT_STRIP_TRAILING_WHITESPACE
+install(
+	FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
+	DESTINATION ${CMAKE_CONFIG_INSTALL_DIR}
+	COMPONENT devel
 )
-
-if (NOT GIT_LOG_RET EQUAL 0)
-	set(GIT_YMD 0)
-endif()
-
-string(REPLACE "-" "" RELEASE_LABEL ${GIT_YMD})
-set(CPACK_RPM_PACKAGE_RELEASE ${RELEASE_LABEL})
-
-set(CPACK_RPM_COMPONENT_INSTALL ON)
-set(CPACK_COMPONENTS_ALL devel)
-set(CPACK_RPM_FILE_NAME RPM-DEFAULT)
-set(CPACK_RPM_PACKAGE_RELEASE_DIST ON)
-
-set(CPACK_RPM_EXCLUDE_FROM_AUTO_FILELIST_ADDITION /usr/lib64/cmake)
-
-set(PB_PACKAGE_REQUIRED "protobuf-devel")
-
-set(CPACK_RPM_DEVEL_PACKAGE_REQUIRES "workflow-devel >= 0.9.9, ${PB_PACKAGE_REQUIRED}")
 
 install(
 	FILES ${INCLUDE_HEADERS}
@@ -172,9 +190,3 @@
 	DESTINATION "${CMAKE_INSTALL_DOCDIR}-${PROJECT_VERSION}"
 	COMPONENT devel
 )
-
-set(CPACK_RPM_SPEC_MORE_DEFINE "%define __spec_install_post /bin/true") # disable strip
-set(CPACK_GENERATOR "RPM")
-
-include(CPack)
-

=== benchmark/CMakeLists.txt ===
--- 
+++ 
@@ -23,6 +23,8 @@
 set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
 if (WIN32)
 	find_package(Protobuf CONFIG REQUIRED)
+	find_library(LZ4_LIBRARY NAMES lz4)
+	find_package(Snappy CONFIG REQUIRED)
 else ()
 	find_package(Protobuf REQUIRED)
 endif ()
@@ -86,15 +88,40 @@
 endif ()
 
 if (APPLE)
-	set(SRPC_LIB srpc workflow pthread OpenSSL::SSL OpenSSL::Crypto protobuf z)
+	set(SRPC_LIB
+		srpc
+		workflow
+		pthread
+		OpenSSL::SSL
+		OpenSSL::Crypto
+		protobuf
+		z
+		)
 elseif (WIN32)
-	set(SRPC_LIB srpc workflow ws2_32 wsock32 OpenSSL::SSL OpenSSL::Crypto)
+	set(SRPC_LIB
+		srpc
+		workflow
+		ws2_32
+		wsock32
+		OpenSSL::SSL
+		OpenSSL::Crypto
+		protobuf::libprotobuf
+		ZLIB::ZLIB
+		Snappy::snappy
+		${LZ4_LIBRARY}
+		)
 else ()
-	if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/snappy/cmake)
-		set(SRPC_LIB srpc snappy lz4)
-	else ()
-		set(SRPC_LIB srpc)
-	endif ()
+	set(SRPC_LIB
+		srpc
+		workflow
+		pthread
+		OpenSSL::SSL
+		OpenSSL::Crypto
+		protobuf
+		z
+		${SNAPPY_LIB}
+		${LZ4_LIB}
+		)
 endif ()
 
 add_executable(server server.cc ${PROTO_SRCS} ${PROTO_HDRS})

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

if (NOT "$ENV{LIBRARY_PATH}" STREQUAL "")
	string(REPLACE ":" ";" LIBRARY_PATH $ENV{LIBRARY_PATH})
	set(CMAKE_SYSTEM_LIBRARY_PATH ${LIBRARY_PATH};${CMAKE_SYSTEM_LIBRARY_PATH})
endif ()

if (NOT "$ENV{CPLUS_INCLUDE_PATH}" STREQUAL "")
	string(REPLACE ":" ";" INCLUDE_PATH $ENV{CPLUS_INCLUDE_PATH})
	set(CMAKE_SYSTEM_INCLUDE_PATH ${INCLUDE_PATH};${CMAKE_SYSTEM_INCLUDE_PATH})
endif ()

find_package(OpenSSL REQUIRED)

set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
if (WIN32)
	find_package(Protobuf REQUIRED CONFIG)
else ()
	find_package(Protobuf 3.11.0 REQUIRED)
endif ()

if (WIN32)
	set (HAVE_SYS_UIO_H_01 false)
else ()
	set (HAVE_SYS_UIO_H_01 true)
endif ()

if (WITH_VCPKG_TOOLCHAIN)
	find_package(Workflow REQUIRED CONFIG)
else ()
	# Try to find the package if workflow is not installed, otherwise proceed with find_package()
	if (NOT WORKFLOW_INSTALLED)
		find_package(Workflow REQUIRED CONFIG HINTS ../workflow)
	endif ()

	if (NOT SNAPPY_INSTALLED)
		set(SNAPPY_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../third_party/snappy)
		configure_file(${SNAPPY_DIR}/cmake/config.h.in ${SNAPPY_DIR}/config.h)
		configure_file(${SNAPPY_DIR}/snappy-stubs-public.h.in ${SNAPPY_DIR}/snappy-stubs-public.h)
	else ()
		find_package(Snappy 1.1.6 REQUIRED CONFIG)
		set(SNAPPY_LIB snappy)
	endif ()

	if (LZ4_INSTALLED)
		set(LZ4_LIB lz4)
	endif ()
endif()

include_directories(
	${OPENSSL_INCLUDE_DIR}
	${CMAKE_CURRENT_SOURCE_DIR}
	${Protobuf_INCLUDE_DIR}
	${WORKFLOW_INCLUDE_DIR}
	${INC_DIR}/srpc
)

if (WIN32)
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP /wd4200 /Zc:__cplusplus /std:c++14")
else ()
	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   -Wall -fPIC -pipe -std=gnu90")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -fPIC -pipe -std=c++11 -fno-exceptions")
endif ()

add_subdirectory(generator)

set(SRC
	rpc_buffer.cc
	rpc_basic.cc
	rpc_global.cc
)

add_subdirectory(module)
add_subdirectory(var)
add_subdirectory(thrift)
add_subdirectory(compress)
add_subdirectory(message)

add_dependencies(module LINK_HEADERS)
add_dependencies(var LINK_HEADERS)
add_dependencies(thrift LINK_HEADERS)
add_dependencies(compress LINK_HEADERS)
add_dependencies(message LINK_HEADERS)


if (WIN32)
	add_library(
		${PROJECT_NAME} STATIC
		${SRC}
		$<TARGET_OBJECTS:module>
		$<TARGET_OBJECTS:var>
		$<TARGET_OBJECTS:thrift>
		$<TARGET_OBJECTS:compress>
		$<TARGET_OBJECTS:message>
	)

	add_dependencies(${PROJECT_NAME} LINK_HEADERS)

	target_compile_definitions(
		${PROJECT_NAME} PRIVATE
		strdup=_strdup
		strcasecmp=_stricmp
		strncasecmp=_strnicmp
	)

	install(
		TARGETS ${PROJECT_NAME}
		ARCHIVE
		DESTINATION ${CMAKE_INSTALL_LIBDIR}
		COMPONENT devel
	)

else ()
	set(STATIC_LIB_NAME ${PROJECT_NAME}-static)
	set(SHARED_LIB_NAME ${PROJECT_NAME}-shared)
	link_directories(${OPENSSL_LINK_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})

	add_library(
		${STATIC_LIB_NAME} STATIC
		${SRC}
		$<TARGET_OBJECTS:module>
		$<TARGET_OBJECTS:var>
		$<TARGET_OBJECTS:thrift>
		$<TARGET_OBJECTS:compress>
		$<TARGET_OBJECTS:message>
	)

	add_library(
		${SHARED_LIB_NAME} SHARED
		${SRC}
		$<TARGET_OBJECTS:module>
		$<TARGET_OBJECTS:var>
		$<TARGET_OBJECTS:thrift>
		$<TARGET_OBJECTS:compress>
		$<TARGET_OBJECTS:message>
	)

	target_link_libraries(${SHARED_LIB_NAME} 
						  OpenSSL::SSL
						  OpenSSL::Crypto
						  pthread
						  protobuf
						  workflow
						  z ${SNAPPY_LIB} ${LZ4_LIB})
		
	set_target_properties(${STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
	set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})

	add_dependencies(${STATIC_LIB_NAME} LINK_HEADERS)
	add_dependencies(${SHARED_LIB_NAME} LINK_HEADERS)

	install(
		TARGETS ${STATIC_LIB_NAME}
		ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
		COMPONENT devel
	)

	install(
		TARGETS ${SHARED_LIB_NAME}
		LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
		COMPONENT devel
	)

endif ()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,7 @@
 endif ()
 
 find_package(OpenSSL REQUIRED)
+find_package(srpc REQUIRED CONFIG HINTS ..)
 
 set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
 if (WIN32)
@@ -48,7 +49,6 @@
 #	find_package(Workflow REQUIRED)
 #endif()
 
-find_package(srpc REQUIRED CONFIG HINTS ..)
 include_directories(
 	${OPENSSL_INCLUDE_DIR}
 	${CMAKE_CURRENT_BINARY_DIR}
@@ -102,9 +102,28 @@
 set(GTEST_LIB GTest::GTest GTest::Main)
 
 if (APPLE)
-	set(SRPC_LIB srpc workflow pthread OpenSSL::SSL OpenSSL::Crypto protobuf z)
+	set(SRPC_LIB
+		srpc
+		workflow
+		pthread
+		OpenSSL::SSL
+		OpenSSL::Crypto
+		protobuf
+		z
+		)
 elseif (WIN32)
-	set(SRPC_LIB srpc workflow ws2_32 wsock32 OpenSSL::SSL OpenSSL::Crypto)
+	set(SRPC_LIB
+		srpc
+		workflow
+		ws2_32
+		wsock32
+		OpenSSL::SSL
+		OpenSSL::Crypto
+		protobuf::libprotobuf
+		ZLIB::ZLIB
+		Snappy::snappy
+		${LZ4_LIBRARY}
+		)
 	set(GTEST_LIB GTest::gtest GTest::gtest_main)
 else ()
 	if (SNAPPY_INSTALLED)
@@ -115,7 +134,17 @@
 		set(LZ4_LIB lz4)
 	endif ()
 
-	set(SRPC_LIB srpc ${SNAPPY_LIB} ${LZ4_LIB})
+	set(SRPC_LIB
+		srpc
+		workflow
+		pthread
+		OpenSSL::SSL
+		OpenSSL::Crypto
+		protobuf
+		z
+		${SNAPPY_LIB}
+		${LZ4_LIB}
+		)
 endif ()
 
 foreach(src ${TEST_LIST})

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -5,6 +5,12 @@
 project(srpc_tutorial
 		LANGUAGES C CXX
 )
+
+###Options
+
+if (WIN32)
+	option(SRPC_TUTORIAL_BUILD_STATIC_RUNTIME "Use static runtime" ON)
+endif ()
 
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR})
 
@@ -19,10 +25,13 @@
 endif ()
 
 find_package(OpenSSL REQUIRED)
+find_package(srpc REQUIRED CONFIG HINTS ..)
 
 set(protobuf_MODULE_COMPATIBLE ON CACHE BOOL "")
 if (WIN32)
 	find_package(Protobuf CONFIG REQUIRED)
+	find_library(LZ4_LIBRARY NAMES lz4)
+	find_package(Snappy CONFIG REQUIRED)
 else ()
 	find_package(Protobuf REQUIRED)
 endif ()
@@ -52,7 +61,6 @@
 #	find_package(Workflow REQUIRED)
 #endif()
 
-find_package(srpc REQUIRED CONFIG HINTS ..)
 include_directories(
 	${OPENSSL_INCLUDE_DIR}
 	${CMAKE_CURRENT_BINARY_DIR}
@@ -61,6 +69,8 @@
 	${SRPC_INCLUDE_DIR}
 )
 
+
+
 if (WIN32)
 	link_directories(${SRPC_LIB_DIR} ${WORKFLOW_LIB_DIR} ${Protobuf_LIB_DIR})
 	set(SRPC_GEN_PROGRAM ${SRPC_BIN_DIR}/Debug/srpc_generator.exe)
@@ -77,9 +87,28 @@
 	TURORIAL_GEN ALL
 	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/echo_pb.proto  ${PROJECT_SOURCE_DIR}
 	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/echo_thrift.thrift ${PROJECT_SOURCE_DIR}
-	COMMAND ${SRPC_GEN_PROGRAM} protobuf ${PROJECT_SOURCE_DIR}/helloworld.proto  ${PROJECT_SOURCE_DIR}
+	COMMAND ${SRPC_GEN_PROGRAM} protobuf ${PROJECT_SOURCE_DIR}/helloworld.proto ${PROJECT_SOURCE_DIR}
 	COMMENT "sprc generator..."
 )
+
+
+if (WIN32)
+	if (SRPC_TUTORIAL_BUILD_STATIC_RUNTIME)
+		set(CompilerFlags
+				CMAKE_CXX_FLAGS
+				CMAKE_CXX_FLAGS_DEBUG
+				CMAKE_CXX_FLAGS_RELEASE
+				CMAKE_CXX_FLAGS_MINSIZEREL
+				CMAKE_C_FLAGS
+				CMAKE_C_FLAGS_DEBUG
+				CMAKE_C_FLAGS_RELEASE
+				CMAKE_C_FLAGS_MINSIZEREL
+				)
+		foreach(CompilerFlag ${CompilerFlags})
+			string(REPLACE "/MD" "/MT" ${CompilerFlag} "${${CompilerFlag}}")
+		endforeach ()
+	endif ()
+endif ()
 
 if (WIN32)
 	set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS}   /MP /wd4200")
@@ -97,14 +126,44 @@
 	tutorial-09-client_task
 	tutorial-10-server_async
 	tutorial-15-srpc_pb_proxy
+	tutorial-16-server_with_metrics
 )
 
 if (APPLE)
-	set(SRPC_LIB srpc workflow pthread OpenSSL::SSL OpenSSL::Crypto protobuf z)
+	set(SRPC_LIB
+		srpc
+		workflow
+		pthread
+		OpenSSL::SSL
+		OpenSSL::Crypto
+		protobuf
+		z
+		)
 elseif (WIN32)
-	set(SRPC_LIB srpc workflow ws2_32 wsock32 OpenSSL::SSL OpenSSL::Crypto protobuf::libprotobuf ZLIB::ZLIB)
-else ()
-	set(SRPC_LIB srpc ${SNAPPY_LIB} ${LZ4_LIB})
+	set(SRPC_LIB
+		srpc
+		workflow
+		ws2_32
+		wsock32
+		OpenSSL::SSL
+		OpenSSL::Crypto
+		protobuf::libprotobuf
+		ZLIB::ZLIB
+		Snappy::snappy
+		${LZ4_LIBRARY}
+		)
+else ()
+	set(SRPC_LIB
+		srpc
+		workflow
+		pthread
+		OpenSSL::SSL
+		OpenSSL::Crypto
+		protobuf
+		z
+		${SNAPPY_LIB}
+		${LZ4_LIB}
+		)
 endif ()
 
 foreach(src ${TUTORIAL_PB_LIST})

=== src/module/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)
project(module)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(PROTO_LIST
	proto/opentelemetry_common.proto
	proto/opentelemetry_resource.proto
	proto/opentelemetry_trace.proto
	proto/opentelemetry_trace_service.proto
	proto/opentelemetry_metrics.proto
	proto/opentelemetry_metrics_service.proto)

protobuf_generate_cpp(PROTO_SRCS PROTO_HDRS ${PROTO_LIST})

set(SRC
	rpc_module.cc
	rpc_filter_span.cc
	rpc_filter_metrics.cc
	${PROTO_SRCS} ${PROTO_HDRS}
)

add_library(${PROJECT_NAME} OBJECT ${SRC})

=== debian/changelog ===
srpc (0.9.7-1build1) lunar; urgency=medium

  * Rebuild against new libprotobuf32.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 04 Jan 2023 17:47:54 +0100

srpc (0.9.7-1) unstable; urgency=low

  * Updated to new version (0.9.7)
  * Restructured package based on feedback. Closes: #1012004
  * Added support for dynamic library (new in 0.9.7) via libsprc0
  * d/control: added breaks/replaces for piuparts

 -- Lance Lin <lqi254@protonmail.com>  Thu, 16 Jun 2022 19:39:19 +0700

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libs
 Priority: optional
 Maintainer: Lance Lin <lqi254@protonmail.com>
-Build-Depends: cmake, debhelper (>= 13), debhelper-compat (= 13),
+Build-Depends: cmake, debhelper-compat (= 13),
 		libworkflow-dev, libssl-dev,
 		libsnappy-dev (>= 1.1.6), libprotobuf-dev (>= 3.12.0),
 		protobuf-compiler, liblz4-dev
@@ -12,10 +12,13 @@
 Vcs-Browser: https://salsa.debian.org/debian/srpc
 Rules-Requires-Root: no
 
-Package: libsrpc
+Package: libsrpc0
 Architecture: any
+Multi-Arch: same
+Breaks: libsrpc (<< 0.9.7-1)
+Replaces: libsrpc (<< 0.9.7-1)
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: Sogou RPC Library (SRPC)
+Description: Sogou RPC Library (SRPC) Generator
  SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
  many small and medium-sized companies.  It handles hundreds of millions of
  requests every day, mainly from search engines. It supports two common IDLs:
@@ -27,7 +30,10 @@
 
 Package: libsrpc-dev
 Architecture: any
-Depends: libsrpc (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
+Breaks: libsrpc (<< 0.9.7-1)
+Replaces: libsrpc (<< 0.9.7-1)
+Depends: libsrpc-bin (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Sogou RPC Library (SRPC)
  SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
  many small and medium-sized companies.  It handles hundreds of millions of
@@ -37,3 +43,19 @@
  tRPC.
  .
  This package contains the development header files.
+
+Package: libsrpc-bin
+Architecture: any
+Multi-Arch: foreign
+Breaks: libsrpc (<< 0.9.7-1)
+Replaces: libsrpc (<< 0.9.7-1)
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Description: Sogou RPC Library (SRPC) Generator
+ SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
+ many small and medium-sized companies.  It handles hundreds of millions of
+ requests every day, mainly from search engines. It supports two common IDLs:
+ protobuf and thrift, and implements several commonly used rpc protocols.
+ It is also an open source version of Tencent's enterprise-level RPC protocol,
+ tRPC.
+ .
+ This package contains the IDL file generator, srpc_generator

## srpc 0.9.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 set(CMAKE_SKIP_RPATH TRUE)
 
 project(srpc
-	VERSION 0.9.7
+	VERSION 0.9.8
 	LANGUAGES C CXX)
 	
 ###Options

=== benchmark/CMakeLists.txt ===
--- 
+++ 
@@ -76,7 +76,7 @@
 	BENCHMARK_GEN ALL
 	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/benchmark_pb.proto  ${PROJECT_SOURCE_DIR}
 	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/benchmark_thrift.thrift ${PROJECT_SOURCE_DIR}
-	COMMENT "sprc generator..."
+	COMMENT "srpc generator..."
 )
 
 if (WIN32)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -16,7 +16,7 @@
 if (WIN32)
 	find_package(Protobuf REQUIRED CONFIG)
 else ()
-	find_package(Protobuf 3.11.0 REQUIRED)
+	find_package(Protobuf 3.5.0 REQUIRED)
 endif ()
 
 if (WIN32)
@@ -145,7 +145,7 @@
 						  z ${SNAPPY_LIB} ${LZ4_LIB})
 		
 	set_target_properties(${STATIC_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
-	set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME})
+	set_target_properties(${SHARED_LIB_NAME} PROPERTIES OUTPUT_NAME ${PROJECT_NAME} VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR} )
 
 	add_dependencies(${STATIC_LIB_NAME} LINK_HEADERS)
 	add_dependencies(${SHARED_LIB_NAME} LINK_HEADERS)

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -96,7 +96,7 @@
 	SRPC_GEN ALL
 	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/test_pb.proto ${PROJECT_SOURCE_DIR}
 	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/test_thrift.thrift ${PROJECT_SOURCE_DIR}
-	COMMENT "sprc generator..."
+	COMMENT "srpc generator..."
 )
 
 set(GTEST_LIB GTest::GTest GTest::Main)

=== tutorial/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,12 @@
 if (WIN32)
 	find_package(Protobuf CONFIG REQUIRED)
 	find_library(LZ4_LIBRARY NAMES lz4)
+	if(LZ4_LIBRARY STREQUAL "LZ4_LIBRARY-NOTFOUND")
+		find_package(lz4)
+		if(lz4_FOUND)
+			set(LZ4_LIBRARY ${lz4_LIBRARIES})
+	    endif()
+	endif()
 	find_package(Snappy CONFIG REQUIRED)
 else ()
 	find_package(Protobuf REQUIRED)
@@ -88,7 +94,7 @@
 	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/echo_pb.proto  ${PROJECT_SOURCE_DIR}
 	COMMAND ${SRPC_GEN_PROGRAM} ${PROJECT_SOURCE_DIR}/echo_thrift.thrift ${PROJECT_SOURCE_DIR}
 	COMMAND ${SRPC_GEN_PROGRAM} protobuf ${PROJECT_SOURCE_DIR}/helloworld.proto ${PROJECT_SOURCE_DIR}
-	COMMENT "sprc generator..."
+	COMMENT "srpc generator..."
 )

=== debian/changelog ===
srpc (0.9.8-1.1) unstable; urgency=medium

  * Non-maintainer upload
  * libsrpc-dev: Add missing Depends (Closes: #1035456)

 -- Bastian Germann <bage@debian.org>  Fri, 12 May 2023 19:39:47 +0200

srpc (0.9.8-1) unstable; urgency=low

  * Updated to new version (0.9.8)
  * d/copyright:
      - update years to 2023
      - edit superfluous file pattern
  * d/control: bump standards version to 4.6.2
  * d/patches:
      - removed obsolete add-soname.patch
      - add description for remove-tutorial-check-targets.patch

 -- Lance Lin <lq27267@gmail.com>  Wed, 01 Mar 2023 21:41:10 +0700

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: srpc
 Section: libs
 Priority: optional
-Maintainer: Lance Lin <lqi254@protonmail.com>
+Maintainer: Lance Lin <lq27267@gmail.com>
 Build-Depends: cmake, debhelper-compat (= 13),
 		libworkflow-dev, libssl-dev,
 		libsnappy-dev (>= 1.1.6), libprotobuf-dev (>= 3.12.0),
 		protobuf-compiler, liblz4-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/sogou/srpc
 Vcs-Git: https://salsa.debian.org/debian/srpc.git
 Vcs-Browser: https://salsa.debian.org/debian/srpc
@@ -18,7 +18,7 @@
 Breaks: libsrpc (<< 0.9.7-1)
 Replaces: libsrpc (<< 0.9.7-1)
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: Sogou RPC Library (SRPC) Generator
+Description: Sogou RPC (SRPC) Runtime Library
  SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
  many small and medium-sized companies.  It handles hundreds of millions of
  requests every day, mainly from search engines. It supports two common IDLs:
@@ -33,7 +33,10 @@
 Multi-Arch: same
 Breaks: libsrpc (<< 0.9.7-1)
 Replaces: libsrpc (<< 0.9.7-1)
-Depends: libsrpc-bin (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
+Depends:
+ libsrpc0 (= ${binary:Version}),
+ libsrpc-bin (= ${binary:Version}),
+ ${misc:Depends}, ${shlibs:Depends}
 Description: Sogou RPC Library (SRPC)
  SRPC is an enterprise-level RPC framework widely used by Tencent, Sogou and
  many small and medium-sized companies.  It handles hundreds of millions of

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

export INSTALL_PREFIX = /usr/

%:
	dh $@  --buildsystem=cmake
